Subject: bug#49570: 28.0.50; url-http proxy connection-wait

From: Lars Ingebrigtsen <[email-masked]>
Date: Thu, 15 Jul 2021 16:47:53 +0200

Madhu <[email-masked]> writes:

> When accessing https://melpa.org (an nginx webserver) through a
> http-proxy (by setting url-proxy-services, say to privoxy), url-http
> hangs when parsing headers. apparently the connection is dropped with
> emacs master. I'm on this commit on master
>
> GNU Emacs 28.0.50 (build 1, x86_64-pc-linux-gnu, X toolkit, cairo
>  version 1.16.0, Xaw3d scroll bars) of 2021-06-15
>  794ec934a76d0647a72b7be32e20dc5b95e5ec11

Could you try updating the branch?  Mattias pushed a connection logic
fix a couple of days ago that may (or may not) change things in this
area.

> If I (setf (url-asynchronous url) t) in lisp/url/url.el:
> (url-retrieve-internal), as per the appended patch, then eventually
> make-network-process gets called with a :nowait t, and the connection
> pulls through.
>
> But I'm not sure if this is the right thing or if the problem is
> elsewhere as this problem doesn't happen on older emacs - say from
> 2020-10-15.

It'd be interesting if you could bisect to the commit that broke this.

> [BTW I haven't seen paul eggert on the lists lately, any word if he is
> still too busy for emacs?]

He was here just the other day.  :-)

> -	(setq asynch t
> -	      loader #'url-proxy))
> +	(progn (setq asynch t
> +	             loader #'url-proxy)
> +               (setf (url-asynchronous url) t)))

Hm...  Looking at the code, I think this patch looks correct.

-- 
(domestic pets only, the antidote for overdose, milk.)
   bloggy blog: http://lars.ingebrigtsen.no